docs: clarify AUTOINSTALL is currently supported on Grml live systems only
[grml-debootstrap.git] / grml-debootstrap
index a67cc75..dcd2b7b 100755 (executable)
@@ -14,8 +14,30 @@ VERSION="${VERSION:-unknown}"
 MNTPOINT="/mnt/debootstrap.$$"
 
 # defaults
-VMSIZE="2G"
+CHROOT_SCRIPTS='yes'
+CONFFILES='/etc/debootstrap'
+DEBCONF='yes'
+DEBIAN_FRONTEND='noninteractive'
+DEBOOTSTRAP='debootstrap'
+EXTRAPACKAGES='yes'
 FORCE=''
+HOSTNAME='grml'
+INITRD='yes'
+INSTALL_NOTES='/etc/debootstrap/install_notes'
+LOCALES='yes'
+MIRROR='http://cdn.debian.net/debian'
+MKFS='mkfs.ext3'
+PACKAGES='yes'
+PRE_SCRIPTS='yes'
+RECONFIGURE='console-data'
+RELEASE='wheezy'
+RM_APTCACHE='yes'
+SCRIPTS='yes'
+SECURE='yes'
+TIMEZONE='Europe/Vienna'
+TUNE2FS='tune2fs -c0 -i0'
+UPGRADE_SYSTEM='yes'
+VMSIZE="2G"
 
 # inside the chroot system locales might not be available, so use minimum:
 export LANG=C
@@ -37,7 +59,7 @@ Bootstrap options:
   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
                          instead of fetching packages from a mirror.
-  -r, --release <name>   Release of new Debian system (default: squeeze).
+  -r, --release <name>   Release of new Debian system (default: wheezy).
   -t, --target <target>  Target partition (/dev/...) or directory where the
                          system should be installed to.
   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
@@ -49,7 +71,6 @@ Bootstrap options:
       --arch <arch>      Set target architecture, use for installing i386 on amd64.
       --filesystem <fs>  Filesystem that should be used when target is a partition
                          or Virtual Machine (see --vmfile).
-      --insecure         Do not download and check Release file signatures.
       --force            Do not prompt for user acknowledgement.
 
 Options for Virtual Machine deployment:
@@ -121,7 +142,7 @@ einfon() {
 
 eerror() {
   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
-  printf " ${BAD}*${NORMAL} $*\n"
+  printf " ${BAD}*${NORMAL} $*\n" >&2
   LAST_E_CMD=eerror
   return 0
 }
@@ -154,47 +175,75 @@ check4progs(){
 # }}}
 
 # helper functions {{{
-# we want to exit smoothly and clean:
-bailout(){
+cleanup() {
+  if [ -n "$CHROOT_VARIABLES" ] ; then
+    einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
+  fi
+
+  if [ -n "$STAGES" ] ; then
+    einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
+  fi
+
+  # Remove temporary mountpoint again
+  if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+    rmdir "$MNTPOINT" 2>/dev/null
+  fi
+
   # make sure $TARGET is not mounted when exiting grml-debootstrap
   if [ -n "$MNTPOINT" ] ; then
-     if grep -q $MNTPOINT /proc/mounts ; then
-        # make sure nothing is left inside chroot so we can unmount it
-        [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
-        [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
-        # ugly, but make sure we really don't leave anything (/proc /proc is intended)
-        for ARG in /sys /proc /proc ; do
-          [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1 || true
-        done
-        umount "$MNTPOINT"/dev >/dev/null 2>&1 || true
-
-        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1 || true
-
-        if [ -n "$DIRECTORY" ] ; then
-          einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
-        else
-          einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
-        fi
-
-        if [ -n "$STAGES" ] ; then
-           echo -n "Removing stages directory ${STAGES}: "
-           rm -rf "$STAGES" && echo done
-        fi
-
-        # remove directory only if we used the default with process id inside the name
-        if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-           einfo "Removing directory ${MNTPOINT}" ; rmdir $MNTPOINT ; eend $?
-        fi
-     fi
+    if grep -q "$MNTPOINT" /proc/mounts ; then
+      # make sure nothing is left inside chroot so we can unmount it
+      [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
+      [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
+
+      [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
+
+      # ugly, but make sure we really don't leave anything (/proc /proc and
+      # /dev /dev are intended, trying to work around timing issues, see #657023)
+      for ARG in /sys /proc /proc /dev /dev ; do
+        [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
+        umount "$MNTPOINT"/$ARG >/dev/null 2>&1
+      done
+
+      if [ -n "$ISODIR" ] ; then
+        [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
+      fi
+
+      if [ -n "$DIRECTORY" ] ; then
+        einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice." ; eend 0
+      else
+        einfo "Unmounting $MNTPOINT"
+        umount "$MNTPOINT"
+        eend $?
+      fi
+
+      if [ -n "$STAGES" ] ; then
+        echo -n "Removing stages directory ${STAGES}: "
+        rm -rf "$STAGES" && echo done
+      fi
+
+      # remove directory only if we used the default with process id inside the name
+      if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
+        einfo "Removing directory ${MNTPOINT}"
+        rmdir "$MNTPOINT"
+        eend $?
+      fi
+    fi
   fi
 
   if [ -n "${ORIG_TARGET}" ] ; then
     einfo "Removing loopback mount of file ${ORIG_TARGET}."
     kpartx -d "${ORIG_TARGET}" ; eend $?
   fi
+}
+
+# we want to exit smoothly and clean:
+bailout(){
+
+  cleanup
 
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
-  [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
+  [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
 
   exit "$EXIT"
 }
@@ -214,7 +263,7 @@ stage() {
 # }}}
 
 # make sure we have what we need {{{
-check4progs debootstrap dialog || exit 1
+check4progs debootstrap || bailout 1
 # }}}
 
 # source main configuration file {{{
@@ -232,7 +281,7 @@ elif [ -r /usr/share/grml-debootstrap/functions/cmdlineopts.clp ] ; then
 else
    eerror "Error: cmdline function file not found, exiting."
    eend 1
-   exit 1
+   bailout 1
 fi
 
 # == business-logic of command line parameter-processing
@@ -242,10 +291,10 @@ fi
   CONFFILES=$_opt_confdir
   einfo "Using config files under $CONFFILES/."
   if ! [ -r "$CONFFILES/config" ] ; then
-    eerror "Error: config file $CONFFILES/config not found."; eend 1; exit 1
+    eerror "Error: config file $CONFFILES/config not found."; eend 1; bailout 1
   fi
   if ! . "$CONFFILES/config" ; then
-    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; exit 1
+    eerror "Error reading config file $CONFFILES/config" ; eend 1 ; bailout 1
   fi
   # restore the command line parameter value
   CONFFILES=$_opt_confdir
@@ -277,7 +326,7 @@ fi
 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
 [ "$_opt_grub" ]                && GRUB=$_opt_grub
 [ "$_opt_arch" ]                && ARCH=$_opt_arch
-[ "$_opt_insecure" ]            && SECURE='false'
+[ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
 [ "$_opt_force" ]               && FORCE=$_opt_force
 [ "$_opt_verbose" ]             && VERBOSE="-v"
 
@@ -298,13 +347,13 @@ fi
 # check for root permissions {{{
 if ! check4root ; then
    echo "For usage instructions please execute '$PN --help'."
-   exit 1
+   bailout 1
 fi
 # }}}
 
 # make sure we have what we need {{{
 if [ -n "$VIRTUAL" ] ; then
-  check4progs kpartx mksh qemu-img || exit 1
+  check4progs kpartx mksh parted qemu-img || bailout 1
 fi
 # }}}
 
@@ -312,7 +361,7 @@ fi
 if [ -n "$CONFIGFILE" ] ; then
    einfo "Reading specified config file $CONFIGFILE."
    if ! . "$CONFIGFILE" ; then
-      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; exit 1
+      eerror "Error reading config file $CONFIGFILE" ; eend 1 ; bailout 1
    fi
 fi
 # }}}
@@ -323,14 +372,14 @@ if [ -n "$GROOT" ] ; then
    eerror "This variable is no longer supported, please visit the"
    eerror "grml-debootstrap documentation for details."
    eend 1
-   exit 1
+   bailout 1
 fi
 
 if echo "$GRUB" | grep -q '^hd' ; then
    eerror "Error: this syntax for the grub configuration variable is no longer supported."
    eerror "Please do not use hd... any longer but /dev/sdX instead."
    eend 1
-   exit 1
+   bailout 1
 fi
 # }}}
 
@@ -355,7 +404,7 @@ prompt_for_target()
      --msgbox "Sorry, no partitions found. Please configure your
      harddisks (see /proc/partitions) using a tool like fdisk,
      cfdisk, gpart, gparted,..." 0 0
-     exit 0
+     bailout 1
   fi
 
   PARTITION_LIST=$(for i in $(echo $AVAILABLE_PARTITIONS) ; do
@@ -365,7 +414,7 @@ prompt_for_target()
   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
          --menu "Please select the target partition:" 0 0 0 \
          $PARTITION_LIST)
-  [ $? -eq 0 ] || bailout
+  [ $? -eq 0 ] || bailout 1
 }
 # }}}
 
@@ -444,13 +493,13 @@ prompt_for_bootmanager()
 # ask for Debian release {{{
 prompt_for_release()
 {
-  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='squeeze'
+  [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='wheezy'
   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
             "Please enter the Debian release you would like to use for installation:" \
             0 50 4 \
-            lenny    Debian/old-stable \
-            squeeze  Debian/stable \
-            wheezy   Debian/testing \
+            lenny    Debian/5.0 \
+            squeeze  Debian/6.0 \
+            wheezy   Debian/7.0 \
             sid      Debian/unstable)"
   [ $? -eq 0 ] || bailout
 }
@@ -591,7 +640,7 @@ $(cat $ERRORFILE)
 
 Exiting." 0 0
    rm -f "$TMPFILE" "$ERRORFILE"
-   exit 1
+   bailout 1
 fi
 
 }
@@ -627,7 +676,7 @@ checkconfiguration()
 if [ -n "$AUTOINSTALL" ] ; then
    if checkforrun ; then
       eerror "Exiting as requested" ; eend 0
-      exit 1
+      bailout 1
    fi
 elif [ -n "$INTERACTIVE" ] ; then
 
@@ -640,11 +689,13 @@ elif [ -n "$INTERACTIVE" ] ; then
    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
    Using release:   $RELEASE"
    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
-   Using hostname   $HOSTNAME"
+   Using hostname:  $HOSTNAME"
    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
    Using mirror:    $MIRROR"
    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
    Using ISO:       $ISO"
+   [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
+   Using arch:      $ARCH"
 
    INFOTEXT="$INFOTEXT
 
@@ -655,7 +706,7 @@ Is this ok for you? Notice: selecting 'No' will exit ${PN}."
    [ $? -eq 0 ] || bailout 0
 
 else # if not running automatic installation display configuration and prompt for execution:
-   einfo "$PN - Please recheck configuration before execution:"
+   einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
    echo
    echo "   Target:          $TARGET"
 
@@ -669,9 +720,10 @@ else # if not running automatic installation display configuration and prompt fo
    fi
 
    [ -n "$RELEASE" ]  && echo "   Using release:   $RELEASE"
-   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$HOSTNAME" ] && echo "   Using hostname:  $HOSTNAME"
+   [ -n "$MIRROR" ]   && echo "   Using mirror:    $MIRROR"
    [ -n "$ISO" ]      && echo "   Using ISO:       $ISO"
+   [ -n "$ARCH" ]     && echo "   Using arch:      $ARCH"
    if [ -n "$VIRTUAL" ] ; then
       echo "   Deploying as Virtual Machine."
       [ -n "$VMSIZE" ] && echo "   Using Virtual Disk file with size of ${VMSIZE}."
@@ -688,7 +740,7 @@ else # if not running automatic installation display configuration and prompt fo
      read a
      if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
         eerror "Exiting as requested." ; eend 1
-        exit 1
+        bailout 1
      fi
    fi
 fi
@@ -698,6 +750,8 @@ fi
 # interactive mode {{{
 interactive_mode()
 {
+  check4progs dialog || bailout 1
+
   welcome_dialog
 
   prompt_for_release
@@ -723,6 +777,17 @@ if [ -z "$TARGET" -o -n "$INTERACTIVE" ] ; then
 fi
 # }}}
 
+# architecture setup {{{
+if [ -n "$ARCH" ] ; then
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+else
+   ARCH="$(dpkg --print-architecture)"
+   ARCHCMD="--arch $ARCH"
+   ARCHINFO=" (${ARCH})"
+fi
+# }}}
+
 checkconfiguration
 
 # finally make sure at least $TARGET is set [the partition for the new system] {{{
@@ -731,7 +796,7 @@ if [ -n "$TARGET" ] ; then
 else
    eerror "Please adjust $CONFFILES/config or..."
    eerror "... use the interactive version for configuration before running ${0}" ; eend 1
-   exit 1
+   bailout 1
 fi
 # }}}
 
@@ -774,30 +839,6 @@ else
 fi
 # }}}
 
-# architecture setup {{{
-if [ -n "$ARCH" ] ; then
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
-else
-   ARCH="$(dpkg --print-architecture)"
-   ARCHCMD="--arch $ARCH"
-   ARCHINFO=" (${ARCH})"
-fi
-# }}}
-
-# keyring setupt {{{
-KEYRING=""
-if [ "$SECURE" = 'yes' ] ; then
-   if [ -e '/etc/apt/trusted.gpg' ] ; then
-      KEYRING="--keyring /etc/apt/trusted.gpg"
-   else
-      eerror "Could not find /etc/apt/trusted.gpg."
-   fi
-else
-   ewarn "Not checking Release signatures!"
-fi
-# }}}
-
 # make sure we have the right syntax when using an iso image {{{
 if [ -n "$ISO" ] ; then
    case $ISO in
@@ -819,7 +860,7 @@ mkfs() {
   else
     if grep -q "$TARGET" /proc/mounts ; then
       eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)" ; eend 1
-      exit 1
+      bailout 1
     fi
 
     if [ -n "$MKFS" ] ; then
@@ -892,7 +933,7 @@ prepare_vm() {
   if [ -b "$TARGET" ] ; then
      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
      eend 1
-     exit 1
+     bailout 1
   fi
 
   ORIG_TARGET="$TARGET" # store for later reuse
@@ -902,10 +943,29 @@ prepare_vm() {
   dd if=/dev/zero bs=1 conv=notrunc count=64 seek=446 of="$TARGET"
   parted -s "${TARGET}" 'mkpart primary ext3 2M -1'
 
+  # if dm-mod isn't available then kpartx will fail with
+  # "Is device-mapper driver missing from kernel? [...]"
+  if ! kpartx -av $TARGET >/dev/null 2>&1 || ! grep -q device-mapper /proc/misc >/dev/null 2>&1 ; then
+    einfo "Device-mapper not ready yet, trying to load dm-mod module."
+    modprobe dm-mod ; eend $?
+  fi
+
+  # make sure loop module is present
+  if ! losetup -f >/dev/null 2>&1; then
+    einfo "Can not find a usable loop device, retrying after loading loop module."
+    modprobe loop
+    if losetup -f >/dev/null 2>&1; then
+      einfo "Found a usable loop device now, continuing."
+    else
+      eerror "Error finding usable loop device" ; eend 1
+      bailout 1
+    fi
+  fi
+
   DEVINFO=$(kpartx -av $TARGET) # 'add map loop1p1 (253:0): 0 6289408 linear /dev/loop1 2048'
   if [ -z "${DEVINFO}" ] ; then
     eerror "Error setting up loopback device." ; eend 1
-    exit 1
+    bailout 1
   fi
 
   # hopefully this always works as expected
@@ -918,7 +978,7 @@ prepare_vm() {
 
   if [ -z "$TARGET" ] ; then
      eerror "Error: target could not be set to according /dev/mapper/* device." ; eend 1
-     exit 1
+     bailout 1
   fi
 }
 # }}}
@@ -931,7 +991,7 @@ finalize_vm() {
 
   if ! mount "${TARGET}" "${MNTPOINT}" ; then
     eerror "Error: Mounting ${TARGET} failed, can not continue." ; eend 1
-    exit 1
+    bailout 1
   fi
 
   einfo "Installing Grub as bootloader."
@@ -942,7 +1002,7 @@ finalize_vm() {
   mkdir -p "${MNTPOINT}/boot/grub"
   if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
      eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader." ; eend 1
-     exit 1
+     bailout 1
   fi
 
   cp "${MNTPOINT}"/usr/lib/grub/i386-pc/* "${MNTPOINT}/boot/grub/"
@@ -951,6 +1011,9 @@ finalize_vm() {
   rm -f "${MNTPOINT}/tmp/core.img"
 
   einfo "Updating grub configuration file."
+  if [ -n "$BOOT_APPEND" ] ; then
+     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}"/etc/default/grub
+  fi
   chroot "${MNTPOINT}" update-grub
 
   umount "${MNTPOINT}"/proc
@@ -960,7 +1023,7 @@ finalize_vm() {
   einfo "Adjusting grub.cfg for successful boot sequence."
   # ugly but needed to boot grub acordingly
   sed -i "s;set root=.*;set root='(hd0,msdos1)';" "${MNTPOINT}"/boot/grub/grub.cfg
-  sed -i "s; root=/dev/.*; root=/dev/sda1;" "${MNTPOINT}"/boot/grub/grub.cfg
+  sed -i "s;root=[^ ]\+;root=/dev/sda1;" "${MNTPOINT}"/boot/grub/grub.cfg
 
   umount "${MNTPOINT}"
   kpartx -d "${ORIG_TARGET}" >/dev/null
@@ -975,19 +1038,33 @@ debootstrap_system() {
   fi
 
   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
-     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
-     if [ -n "$MIRROR" ] ; then
-        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
-        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
-     else
-        einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
-        $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
-     fi
-     eend $?
+    :
   else
-     eerror "Error: $MNTPOINT not mounted, can not continue."
-     eend 1
+    eerror "Error: $MNTPOINT not mounted, can not continue."
+    eend 1 ; exit 1
   fi
+
+  einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
+  if [ -n "$MIRROR" ] ; then
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
+    $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR
+    RC=$?
+  else
+    einfo "Executing: $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
+    $DEBOOTSTRAP $ARCHCMD $KEYRING $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO
+    RC=$?
+  fi
+
+  if [ $RC -ne 0 ] ; then
+    if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
+      [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
+      einfo "Presenting last ten lines of debootstrap.log:"
+      tail -10 $MNTPOINT/debootstrap/debootstrap.log
+      einfo "End of debootstrap.log"
+    fi
+  fi
+
+  eend $RC
 }
 # }}}
 
@@ -1000,22 +1077,41 @@ preparechroot() {
   touch $CHROOT_VARIABLES
   chmod 600 $CHROOT_VARIABLES # make sure nobody except root can read it
   echo "# Configuration of ${PN}"                              > $CHROOT_VARIABLES
-  [ -n "$ARCH" ]          && echo "ARCH=$ARCH"                 >> $CHROOT_VARIABLES
-  [ -n "$GRUB" ]          && echo "GRUB=$GRUB"                 >> $CHROOT_VARIABLES
-  [ -n "$HOSTNAME" ]      && echo "HOSTNAME=$HOSTNAME"         >> $CHROOT_VARIABLES
-  [ -n "$INSTALL_NOTES" ] && echo "INSTALL_NOTES=$INSTALL_NOTES" >> $CHROOT_VARIABLES
-  [ -n "$ISODIR" ]        && echo "ISODIR=$ISO"                >> $CHROOT_VARIABLES
-  [ -n "$ISO" ]           && echo "ISO=$ISO"                   >> $CHROOT_VARIABLES
-  [ -n "$KEEP_SRC_LIST" ] && echo "KEEP_SRC_LIST=$KEEP_SRC_LIST" >> $CHROOT_VARIABLES
-  [ -n "$MIRROR" ]        && echo "MIRROR=$MIRROR"             >> $CHROOT_VARIABLES
-  [ -n "$PACKAGES" ]      && echo "PACKAGES=$PACKAGES"         >> $CHROOT_VARIABLES
-  [ -n "$GRMLREPOS" ]     && echo "GRMLREPOS=$GRMLREPOS"       >> $CHROOT_VARIABLES
-  [ -n "$RM_APTCACHE" ]   && echo "RM_APTCACHE=$RM_APTCACHE"   >> $CHROOT_VARIABLES
-  [ -n "$ROOTPASSWORD" ]  && echo "ROOTPASSWORD=$ROOTPASSWORD" >> $CHROOT_VARIABLES
-  [ -n "$NOPASSWORD" ]    && echo "NOPASSWORD=true"            >> $CHROOT_VARIABLES
-  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=$SELECTED_PARTITIONS" >> $CHROOT_VARIABLES
-  [ -n "$TARGET" ]        && echo "TARGET=$TARGET"             >> $CHROOT_VARIABLES
-  [ -n "$TARGET_UUID" ]   && echo "TARGET_UUID=$TARGET_UUID"   >> $CHROOT_VARIABLES
+  [ -n "$ARCH" ]                && echo "ARCH=\"$ARCH\""                               >> $CHROOT_VARIABLES
+  [ -n "$CHROOT_SCRIPTS" ]      && echo "CHROOT_SCRIPTS=\"$CHROOT_SCRIPTS\""           >> $CHROOT_VARIABLES
+  [ -n "$CONFFILES" ]           && echo "CONFFILES=\"$CONFFILES\""                     >> $CHROOT_VARIABLES
+  [ -n "$DEBCONF" ]             && echo "DEBCONF=\"$DEBCONF\""                         >> $CHROOT_VARIABLES
+  [ -n "$DEBIAN_FRONTEND" ]     && echo "DEBIAN_FRONTEND=\"$DEBIAN_FRONTEND\""         >> $CHROOT_VARIABLES
+  [ -n "$DEBOOTSTRAP" ]         && echo "DEBOOTSTRAP=\"$DEBOOTSTRAP\""                 >> $CHROOT_VARIABLES
+  [ -n "$EXTRAPACKAGES" ]       && echo "EXTRAPACKAGES=\"$EXTRAPACKAGES\""             >> $CHROOT_VARIABLES
+  [ -n "$FORCE" ]               && echo "FORCE=\"$FORCE\""                             >> $CHROOT_VARIABLES
+  [ -n "$GRMLREPOS" ]           && echo "GRMLREPOS=\"$GRMLREPOS\""                     >> $CHROOT_VARIABLES
+  [ -n "$GRUB" ]                && echo "GRUB=\"$GRUB\""                               >> $CHROOT_VARIABLES
+  [ -n "$HOSTNAME" ]            && echo "HOSTNAME=\"$HOSTNAME\""                       >> $CHROOT_VARIABLES
+  [ -n "$INITRD" ]              && echo "INITRD=\"$INITRD\""                           >> $CHROOT_VARIABLES
+  [ -n "$INSTALL_NOTES" ]       && echo "INSTALL_NOTES=\"$INSTALL_NOTES\""             >> $CHROOT_VARIABLES
+  [ -n "$ISODIR" ]              && echo "ISODIR=\"$ISO\""                              >> $CHROOT_VARIABLES
+  [ -n "$ISO" ]                 && echo "ISO=\"$ISO\""                                 >> $CHROOT_VARIABLES
+  [ -n "$KEEP_SRC_LIST" ]       && echo "KEEP_SRC_LIST=\"$KEEP_SRC_LIST\""             >> $CHROOT_VARIABLES
+  [ -n "$LOCALES" ]             && echo "LOCALES=\"$LOCALES\""                         >> $CHROOT_VARIABLES
+  [ -n "$MIRROR" ]              && echo "MIRROR=\"$MIRROR\""                           >> $CHROOT_VARIABLES
+  [ -n "$MKFS" ]                && echo "MKFS=\"$MKFS\""                               >> $CHROOT_VARIABLES
+  [ -n "$NOPASSWORD" ]          && echo "NOPASSWORD=\"true\""                          >> $CHROOT_VARIABLES
+  [ -n "$PACKAGES" ]            && echo "PACKAGES=\"$PACKAGES\""                       >> $CHROOT_VARIABLES
+  [ -n "$PRE_SCRIPTS" ]         && echo "PRE_SCRIPTS=\"$PRE_SCRIPTS\""                 >> $CHROOT_VARIABLES
+  [ -n "$RECONFIGURE" ]         && echo "RECONFIGURE=\"$RECONFIGURE\""                 >> $CHROOT_VARIABLES
+  [ -n "$RELEASE" ]             && echo "RELEASE=\"$RELEASE\""                         >> $CHROOT_VARIABLES
+  [ -n "$RM_APTCACHE" ]         && echo "RM_APTCACHE=\"$RM_APTCACHE\""                 >> $CHROOT_VARIABLES
+  [ -n "$ROOTPASSWORD" ]        && echo "ROOTPASSWORD=\"$ROOTPASSWORD\""               >> $CHROOT_VARIABLES
+  [ -n "$SCRIPTS" ]             && echo "SCRIPTS=\"$SCRIPTS\""                         >> $CHROOT_VARIABLES
+  [ -n "$SECURE" ]              && echo "SECURE=\"$SECURE\""                           >> $CHROOT_VARIABLES
+  [ -n "$SELECTED_PARTITIONS" ] && echo "SELECTED_PARTITIONS=\"$SELECTED_PARTITIONS\"" >> $CHROOT_VARIABLES
+  [ -n "$TARGET" ]              && echo "TARGET=\"$TARGET\""                           >> $CHROOT_VARIABLES
+  [ -n "$UPGRADE_SYSTEM" ]      && echo "UPGRADE_SYSTEM=\"$UPGRADE_SYSTEM\""           >> $CHROOT_VARIABLES
+  [ -n "$TARGET_UUID" ]         && echo "TARGET_UUID=\"$TARGET_UUID\""                 >> $CHROOT_VARIABLES
+  [ -n "$TIMEZONE" ]            && echo "TIMEZONE=\"$TIMEZONE\""                       >> $CHROOT_VARIABLES
+  [ -n "$TUNE2FS" ]             && echo "TUNE2FS=\"$TUNE2FS\""                         >> $CHROOT_VARIABLES
+  [ -n "$VMSIZE" ]              && echo "VMSIZE=\"$VMSIZE\""                           >> $CHROOT_VARIABLES
 
   cp $VERBOSE $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
   chmod 755 $MNTPOINT/bin/chroot-script
@@ -1127,18 +1223,29 @@ execute_scripts() {
 # execute chroot-script {{{
 chrootscript() {
   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
-     mount_target
+    mount_target
   fi
 
-  if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
-     einfo "Executing chroot-script now"
-     mount --bind /dev "$MNTPOINT"/dev
-     chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
-     umount "$MNTPOINT"/dev
-     eend $RC
+  if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
+    eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
+    eend 1
   else
-     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
-     eend 1
+    einfo "Executing chroot-script now"
+    mount --bind /dev "$MNTPOINT"/dev
+    chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
+    umount "$MNTPOINT"/dev
+    eend $RC
+  fi
+
+  # finally get rid of chroot-script again, there's no good reason to
+  # keep it on the installed system
+  if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
+    einfo "Removing chroot-script again"
+    rm -f "${MNTPOINT}/bin/chroot-script"
+    eend $?
+  else
+    einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
+    eend 0
   fi
 }
 # }}}
@@ -1172,7 +1279,7 @@ umount_chroot() {
 # execute filesystem check {{{
 fscktool() {
  if [ -n "$VIRTUAL" ] ; then
-   einfo "Skipping filesystem check since we deploy a virtual machine."
+   einfo "Skipping filesystem check because we deploy a virtual machine."
    return 0
  fi
 
@@ -1190,19 +1297,11 @@ for i in prepare_vm mkfs tunefs mount_target debootstrap_system \
          preparechroot execute_pre_scripts chrootscript execute_scripts \
          umount_chroot finalize_vm fscktool ; do
     if stage "${i}" ; then
-       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "i"
+       $i && ( stage "${i}" done && rm -f "${STAGES}/${i}" ) || bailout 2 "$i"
     fi
 done
-# }}}
 
-# finalize {{{
-einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" ; eend $?
-einfo "Removing ${STAGES}" ; rmdir "$STAGES" ; eend $?
-
-# Remove temporary mountpoint again
-if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
-   einfo "Removing directory ${MNTPOINT}" ; rmdir "$MNTPOINT" ; eend $?
-fi
+cleanup
 # }}}
 
 # end dialog of autoinstallation {{{